#include <quicktime/lqt.h>
#include <quicktime/colormodels.h>
#include <funcprotos.h>
#include "lqt_xanim.h"

xaULONG QT_Decode_RPZA(xaUBYTE *image, xaUBYTE *delta, xaULONG dsize,
                       XA_DEC_INFO *dec_info);

static int decode_rpza(quicktime_t *file, unsigned char **row_pointers,
                       int track)
  {
  quicktime_video_map_t *vtrack = &(file->vtracks[track]);
  lqt_xanim_codec_1_t *codec = (lqt_xanim_codec_1_t*)(((quicktime_codec_t*)vtrack->codec)->priv);

  xaULONG (*decode_func)(xaUBYTE *, xaUBYTE *, xaULONG, XA_DEC_INFO *) =
    (xaULONG (*)(xaUBYTE *, xaUBYTE *, xaULONG, XA_DEC_INFO *))0;
    
  if(!codec->initialized)
    {
    lqt_xanim_init_vcodec_1(file, track);
    
    switch(quicktime_video_depth(file, track))
      {
      case 16:
        decode_func = QT_Decode_RPZA;
        break;
      default:
        break;
      }
    codec->decode_func = decode_func;
    lqt_xanim_alloc_temp_frame_1(file, track);
    codec->initialized = 1;
    }
  return lqt_xanim_decode_video_1(file, row_pointers, track);
  }

void lqt_xanim_init_codec_rpza(quicktime_video_map_t *vtrack)
  {
  lqt_xanim_codec_1_t *codec;

  /* Init public items */
  ((quicktime_codec_t*)vtrack->codec)->priv = calloc(1, sizeof(lqt_xanim_codec_1_t));
  ((quicktime_codec_t*)vtrack->codec)->delete_vcodec = lqt_xanim_delete_vcodec_1;
  ((quicktime_codec_t*)vtrack->codec)->decode_video = decode_rpza;
  ((quicktime_codec_t*)vtrack->codec)->encode_video = 0;
  ((quicktime_codec_t*)vtrack->codec)->set_parameter = 0;
  ((quicktime_codec_t*)vtrack->codec)->decode_audio = 0;
  ((quicktime_codec_t*)vtrack->codec)->encode_audio = 0;
  ((quicktime_codec_t*)vtrack->codec)->reads_colormodel = lqt_xanim_reads_colormodel;
  }
